unit U_ZZJWLRKList;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, cxStyles, cxCustomData, cxGraphics, cxFilter, cxData, cxDataStorage,
  cxEdit, DB, cxDBData, cxGridCustomTableView, cxGridTableView,
  cxGridBandedTableView, cxGridDBBandedTableView, cxGridLevel, cxClasses,
  cxControls, cxGridCustomView, cxGridDBTableView, cxGrid, StdCtrls, ComCtrls,
  ExtCtrls, ToolWin, cxGridCustomPopupMenu, cxGridPopupMenu, ADODB, DBClient,
  cxDropDownEdit, cxCheckBox, RM_Common, RM_Class, RM_e_Xls, RM_Dataset,
  RM_System, RM_GridReport, Menus, cxCalendar, cxButtonEdit, cxTextEdit, cxPC,
  cxLookAndFeels, cxLookAndFeelPainters, cxNavigator, dxBarBuiltInMenu,
  cxContainer, cxMaskEdit, dxSkinsCore, dxSkinsDefaultPainters,
  dxSkinscxPCPainter, dxSkinBlack, dxSkinBlue, dxSkinBlueprint,
  dxSkinCaramel, dxSkinCoffee, dxSkinDarkRoom, dxSkinDarkSide,
  dxSkinDevExpressDarkStyle, dxSkinDevExpressStyle, dxSkinFoggy,
  dxSkinGlassOceans, dxSkinHighContrast, dxSkiniMaginary, dxSkinLilian,
  dxSkinLiquidSky, dxSkinLondonLiquidSky, dxSkinMcSkin, dxSkinMetropolis,
  dxSkinMetropolisDark, dxSkinMoneyTwins, dxSkinOffice2007Black,
  dxSkinOffice2007Blue, dxSkinOffice2007Green, dxSkinOffice2007Pink,
  dxSkinOffice2007Silver, dxSkinOffice2010Black, dxSkinOffice2010Blue,
  dxSkinOffice2010Silver, dxSkinOffice2013DarkGray,
  dxSkinOffice2013LightGray, dxSkinOffice2013White, dxSkinPumpkin,
  dxSkinSeven, dxSkinSevenClassic, dxSkinSharp, dxSkinSharpPlus,
  dxSkinSilver, dxSkinSpringTime, dxSkinStardust, dxSkinSummer2008,
  dxSkinTheAsphaltWorld, dxSkinValentine, dxSkinVS2010, dxSkinWhiteprint,
  dxSkinXmas2008Blue;

type
  TfrmZZJWLRKList = class(TForm)
    ToolBar1: TToolBar;
    TBRafresh: TToolButton;
    TBFind: TToolButton;
    TBExport: TToolButton;
    TBClose: TToolButton;
    Panel1: TPanel;
    ADOQueryCmd: TADOQuery;
    ADOQueryMain: TADOQuery;
    ADOQueryTemp: TADOQuery;
    DataSource1: TDataSource;
    cxGridPopupMenu1: TcxGridPopupMenu;
    Label1: TLabel;
    Label2: TLabel;
    BegDate: TDateTimePicker;
    EndDate: TDateTimePicker;
    CDS_Main: TClientDataSet;
    RM1: TRMGridReport;
    RMDBMain: TRMDBDataSet;
    RMXLSExport1: TRMXLSExport;
    RMDBHZ: TRMDBDataSet;
    CDS_HZ: TClientDataSet;
    CDS_PRT: TClientDataSet;
    TBDel: TToolButton;
    PopupMenu1: TPopupMenu;
    N1: TMenuItem;
    N2: TMenuItem;
    TBAdd: TToolButton;
    TBEdit: TToolButton;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label8: TLabel;
    Label12: TLabel;
    SPName: TEdit;
    FactoryName: TEdit;
    SPID: TEdit;
    BatchNo: TEdit;
    CRType: TComboBox;
    Label10: TLabel;
    SPCOLOR: TEdit;
    TBZF: TToolButton;
    cxTabControl1: TcxTabControl;
    Label6: TLabel;
    Note: TEdit;
    cxGrid2: TcxGrid;
    Tv1: TcxGridDBTableView;
    v1Column6: TcxGridDBColumn;
    v1Column2: TcxGridDBColumn;
    v1Column4: TcxGridDBColumn;
    v1Column18: TcxGridDBColumn;
    Tv1Column1: TcxGridDBColumn;
    v1Column14: TcxGridDBColumn;
    v1Column15: TcxGridDBColumn;
    v2Column1: TcxGridDBColumn;
    Tv1Column8: TcxGridDBColumn;
    v1Column8: TcxGridDBColumn;
    v1Column1: TcxGridDBColumn;
    Tv1Column2: TcxGridDBColumn;
    v2Column6: TcxGridDBColumn;
    Tv1Column3: TcxGridDBColumn;
    Tv1Column7: TcxGridDBColumn;
    v1Column3: TcxGridDBColumn;
    Tv1Column4: TcxGridDBColumn;
    Tv1Column6: TcxGridDBColumn;
    Tv1Column5: TcxGridDBColumn;
    v1Column12: TcxGridDBColumn;
    v1Column11: TcxGridDBColumn;
    cxGrid2Level1: TcxGridLevel;
    Tv1Column9: TcxGridDBColumn;
    Tv1Column10: TcxGridDBColumn;
    Tv1Column11: TcxGridDBColumn;
    Label7: TLabel;
    JWLTYPE: TComboBox;
    Tv1Column12: TcxGridDBColumn;
    ToolButton1: TToolButton;
    Panel2: TPanel;
    Label9: TLabel;
    Label11: TLabel;
    Edit2: TEdit;
    Edit3: TEdit;
    Button1: TButton;
    Button2: TButton;
    Tv1Column13: TcxGridDBColumn;
    ADOPrint: TADOQuery;
    Tv1Column14: TcxGridDBColumn;
    Label13: TLabel;
    tpno: TEdit;
    ToolButton2: TToolButton;
    Label14: TLabel;
    Label15: TLabel;
    ORDERNO: TEdit;
    Label16: TLabel;
    JWLLABNAME: TcxButtonEdit;
    Tv1Column15: TcxGridDBColumn;
    Button3: TButton;
    Tv1Column16: TcxGridDBColumn;
    procedure FormDestroy(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure TBRafreshClick(Sender: TObject);
    procedure ConNoMChange(Sender: TObject);
    procedure TBCloseClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure TBExportClick(Sender: TObject);
    procedure TBFindClick(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure N2Click(Sender: TObject);
    procedure TBDelClick(Sender: TObject);
    procedure TBAddClick(Sender: TObject);
    procedure TBEditClick(Sender: TObject);
    procedure SPIDChange(Sender: TObject);
    procedure BatchNoChange(Sender: TObject);
    procedure FactoryNameChange(Sender: TObject);
    procedure TBZFClick(Sender: TObject);
    procedure cxTabControl1Change(Sender: TObject);
    procedure TBPriceClick(Sender: TObject);
    procedure chkpriceClick(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton2Click(Sender: TObject);
    procedure JWLLABNAMEPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
    procedure Button3Click(Sender: TObject);
  private
    canshu1, canshu2, canshu3: string;
    procedure InitGrid();
    procedure SetStatus();
    { Private declarations }
  public
    { Public declarations }
  end;

//var
 // frmShaRKList: TfrmShaRKList;

implementation

uses
  U_DataLink, U_RTFun, U_ShaRKInPut, U_Fun, U_ZDYHelp;

{$R *.dfm}
procedure TfrmZZJWLRKList.SetStatus();
begin
  TBAdd.Visible := False;
  TBDel.Visible := False;
  TBEdit.Visible := False;
  TBZF.Visible := False;
  cxTabControl1.Visible := False;

  if Trim(Self.Caption) = '机物料入库管理' then
  begin
    TBAdd.Visible := True;
    TBDel.Visible := True;
    TBEdit.Visible := True;
    TBZF.Visible := True;
    cxTabControl1.Visible := True;
  end;

  if Trim(Self.Caption) = '机物料入库管理(高权限)' then
  begin
    TBAdd.Visible := True;
    TBDel.Visible := True;
    TBEdit.Visible := True;
    TBZF.Visible := True;
    cxTabControl1.Visible := True;
  end;

end;

procedure TfrmZZJWLRKList.FormDestroy(Sender: TObject);
begin
  //frmShaRKList:=nil;
end;

procedure TfrmZZJWLRKList.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Action := caFree;
end;

procedure TfrmZZJWLRKList.FormCreate(Sender: TObject);
begin
  //cxGrid1.Align:=alClient;
  EndDate.DateTime := SGetServerDate10(ADOQueryTemp);
  BegDate.DateTime := EndDate.DateTime - 30;
  canshu1 := Trim(DParameters1);
  canshu2 := Trim(DParameters2);
  canshu3 := Trim(DParameters3);
end;

procedure TfrmZZJWLRKList.InitGrid();
begin
  try
    ADOQueryMain.DisableControls;
    with ADOQueryMain do
    begin
      Filtered := False;
      Close;
      sql.Clear;
      sql.Add(' select A.* ');
      SQL.Add(',CYMJID=(select CYID FROM fl_ydang B WHERE B.CYmjID=A.CYID )');
      sql.Add(' from CK_SXPB_CR A');
      sql.add(' where A.CRTime>=''' + Trim(FormatDateTime('yyyy-MM-dd', BegDate.DateTime)) + '''');
      sql.Add(' and A.CRTime<''' + Trim(FormatDateTime('yyyy-MM-dd', enddate.DateTime + 1)) + '''');
      sql.Add(' and isnull(CKName,'''')=''机物料''');
      SQL.Add(' and CRFlag=''入库''  ');

      if cxTabControl1.TabIndex = 0 then
      begin
        Sql.Add(' and ZFFlag=0 ');
      end
      else if cxTabControl1.TabIndex = 1 then
      begin
        Sql.Add(' and ZFFlag=1 ');
      end;
      if Trim(Self.Caption) = '机物料入库管理' then
      begin
        Sql.Add(' and Filler=' + quotedstr(Trim(DName)));
      end;
      SQL.Add(' order by CRTime desc');
      Open;
    end;
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  finally
    ADOQueryMain.EnableControls;
  end;
end;

procedure TfrmZZJWLRKList.TBRafreshClick(Sender: TObject);
begin
  BegDate.SetFocus;
  InitGrid();
end;

procedure TfrmZZJWLRKList.ConNoMChange(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
  end;
end;

procedure TfrmZZJWLRKList.TBCloseClick(Sender: TObject);
begin
  WriteCxGrid('机物料入库列表', Tv1, '机物料仓库9');
  Close;
end;

procedure TfrmZZJWLRKList.FormShow(Sender: TObject);
begin
  ReadCxGrid('机物料入库列表', Tv1, '机物料仓库9');
  SetStatus();

  //InitGrid();
end;

procedure TfrmZZJWLRKList.TBExportClick(Sender: TObject);
begin
  if ADOQueryMain.IsEmpty then
    exit;
  TcxGridToExcel('机物料入库列表', cxGrid2);
end;

procedure TfrmZZJWLRKList.TBFindClick(Sender: TObject);
begin
  if ADOQueryMain.Active then
  begin
    SDofilter(ADOQueryMain, SGetFilters(Panel1, 1, 2));
    SCreateCDS20(ADOQueryMain, CDS_Main);
    SInitCDSData20(ADOQueryMain, CDS_Main);
  end;
end;

procedure TfrmZZJWLRKList.N1Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, True);
end;

procedure TfrmZZJWLRKList.N2Click(Sender: TObject);
begin
  SelOKNo(CDS_Main, False);
end;

procedure TfrmZZJWLRKList.TBDelClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from YF_Money_CR where YFTypeId=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已经生成应付款不能删除!', '提示', 0);
      Exit;
    end;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      sql.Add(' and CRQtyFlag=-1');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已有出库记录，不能删除!', '提示', 0);
      Exit;
    end;
    if Application.MessageBox('确定要删除数据吗？', '提示', 32 + 4) <> IDYES then
      Exit;
    try
      ADOQueryCmd.Connection.BeginTrans;

      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' delete CK_SXPB_CR where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('删除异常!', '提示', 0);
    end;

  end
  else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmZZJWLRKList.TBAddClick(Sender: TObject);
begin
  try
    frmShaRKInPut := TfrmShaRKInPut.Create(Application);
    with frmShaRKInPut do
    begin
      FBCId := '';
      frmShaRKInPut.canshu3 := Trim(Self.canshu3);
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmShaRKInPut.Free;
  end;
end;

procedure TfrmZZJWLRKList.TBEditClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
//  with ADOQueryTemp do
//  begin
//    Close;
//    sql.Clear;
//    sql.Add('select * from YF_Money_CR where YFTypeId=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
//    Open;
//  end;
//  if ADOQueryTemp.IsEmpty = False then
//  begin
//    Application.MessageBox('已经生成应付款不能修改!', '提示', 0);
//    Exit;
//  end;
  try
    frmShaRKInPut := TfrmShaRKInPut.Create(Application);
    with frmShaRKInPut do
    begin
      FBCId := Trim(CDS_Main.fieldbyname('SPID').AsString);
      TBDel.Visible := False;
      TBAdd.Visible := False;
      if ShowModal = 1 then
      begin
        Self.InitGrid();
      end;
    end;
  finally
    frmShaRKInPut.Free;
  end;
end;

procedure TfrmZZJWLRKList.SPIDChange(Sender: TObject);
begin
  if Length(Trim(SPID.Text)) < 4 then
  begin
    if Trim(SPID.Text) <> '' then
      Exit;
  end;
  TBFind.Click;
end;

procedure TfrmZZJWLRKList.BatchNoChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmZZJWLRKList.FactoryNameChange(Sender: TObject);
begin
  TBFind.Click;
end;

procedure TfrmZZJWLRKList.TBZFClick(Sender: TObject);
begin
  if CDS_Main.IsEmpty then
    Exit;
  if cxTabControl1.TabIndex <> 0 then
    Exit;
  if Trim(CDS_Main.fieldbyname('SPID').AsString) <> '' then
  begin
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from YF_Money_CR where YFTypeId=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      Application.MessageBox('已经生成应付款不能作废!', '提示', 0);
      Exit;
    end;
    with ADOQueryTemp do
    begin
      Close;
      sql.Clear;
      sql.Add('select * from CK_SXPB_CR where FZSPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
      sql.Add(' and CRQtyFlag=-1 and ZFFlag=0 ');
      Open;
    end;
    if ADOQueryTemp.IsEmpty = False then
    begin
      if Application.MessageBox('已有出库记录，确定连同出库记录一起作废吗？', '提示', 32 + 4) <> IDYES then
        Exit;
    end
    else
    begin
      if Application.MessageBox('确定要作废此入库记录吗？', '提示', 32 + 4) <> IDYES then
        Exit;
    end;

    try
      ADOQueryCmd.Connection.BeginTrans;
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' UPdate CK_SXPB_CR Set ZFFlag=1,ZFTime=Getdate(),ZFPerson=''' + Trim(DName) + '''');
        sql.Add(' where FZSPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        ExecSQL;
      end;
      ADOQueryCmd.Connection.CommitTrans;
      CDS_Main.Delete;
    except
      ADOQueryCmd.Connection.RollbackTrans;
      Application.MessageBox('作废异常!', '提示', 0);
    end;

  end
  else
  begin
    CDS_Main.Delete;
  end;
end;

procedure TfrmZZJWLRKList.cxTabControl1Change(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmZZJWLRKList.TBPriceClick(Sender: TObject);
var
  str: string;
  dstr: Double;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if InputQuery('单价修改', '请输入数字', str) then
  begin
    if TryStrToFloat(str, dstr) then
    begin
      with ADOQueryCmd do
      begin
        Close;
        sql.Clear;
        sql.Add(' UPdate CK_SXPB_CR Set Price=' + str);
        sql.Add(' , Money=' + str + '*Qty ');
        sql.Add(' where SPID=''' + Trim(CDS_Main.fieldbyname('SPID').AsString) + '''');
        ExecSQL;
      end;
      Application.MessageBox('确认成功!', '提示', 0);
      with CDS_Main do
      begin
        Edit;
        FieldByName('Price').Value := dstr;
        FieldByName('Money').Value := FieldByName('Qty').AsFloat * dstr;
      end;
    end
    else
    begin
      Application.MessageBox('请输入数字!', '提示', 0);
    end;
  end;

end;

procedure TfrmZZJWLRKList.chkpriceClick(Sender: TObject);
begin
  InitGrid();
end;

procedure TfrmZZJWLRKList.ToolButton1Click(Sender: TObject);
begin
  panel2.Visible := True;
//  Edit2.Text := Trim(CDS_Main.fieldbyname('piqty').AsString);
end;

procedure TfrmZZJWLRKList.Button2Click(Sender: TObject);
begin
  Panel2.Visible := False;
end;

procedure TfrmZZJWLRKList.Button1Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  FLABNAME: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
//  if Edit2.Text = '' then
//  begin
//    application.MessageBox('每箱盒数不能为空！', '提示信息', MB_ICONERROR);
//    Exit;
//  end;
  if Edit3.Text = '' then
  begin
    application.MessageBox('打印份数不能为空！', '提示信息', MB_ICONERROR);
    Exit;
  end;

  if JWLLABNAME.Text = '' then
  begin
    FLABNAME := '机物料出库单';
  end
  else
  begin
    FLABNAME := JWLLABNAME.Text;
  end;
  ExportFtErpFile(FLABNAME + '.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\' + FLABNAME + '.rmf';

  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not Eof do
    begin
      if CDS_Main.FieldByName('SSel').AsBoolean = True then
      begin
        with ADOPrint do
        begin
          Close;
          sql.Clear;
          SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYmjID=A.CYID)');
          SQL.Add(',CYCF=(select CYCF FROM fl_ydang B WHERE B.CYmjID=A.CYID) from ck_sxpb_cr A where spid=' + QUOTEDSTR(Trim(CDS_Main.fieldbyname('spid').AsString)));
          Open;

        end;

        if FileExists(fPrintFile) then
        begin
          if Edit2.Text <> '' then
          begin
            RMVariables['SL'] := Trim(Edit2.text);
          end
          else
          begin
            RMVariables['SL'] := ADOPrint.FieldByName('piQty').AsFloat;
          end;



//
//    //RMVariables['enddate']:=enddate.DateTime;
//    try
//      Moudle := LoadLibrary('MakeQRBarcode.dll');
//      @Makebar := GetProcAddress(Moudle, 'Make');
//      @Mixtext := GetProcAddress(Moudle, 'MixText');
//      Txt := Trim((trim(CDS_Main.fieldbyname('spid').AsString)));
//      fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
//      if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
//        CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
//      if FileExists(fImagePath) then
//        DeleteFile(fImagePath);
//      Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
//    except
//      application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
//      exit;
//    end;
          RM1.LoadFromFile(fPrintFile);
          RMVariables['QRBARCODE'] := fImagePath;
          RMVariables['CYMJID'] := CDS_Main.FIELDBYNAME('CYMJID').AsString;
          if (ADOPrint.FieldByName('qtyunit').ASSTRING = '箱') then
          begin

            Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1) * strtointdef(ADOPrint.FieldByName('zhs').AsString, 1);

          end
          else
          begin
            Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1);
          end;

          RM1.PrintReport;
        end
        else
        begin
          Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
        end;
      end;
      Next;
    end;
  end;
  CDS_Main.EnableControls;

end;

procedure TfrmZZJWLRKList.ToolButton2Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  wsql: string;
begin
  if CDS_Main.IsEmpty then
    Exit;

  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
  ExportFtErpFile('机物料入库单.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\机物料入库单.rmf';
  CDS_Main.DisableControls;
  with CDS_Main do
  begin

    wsql := ' ';
    First;
    while not Eof do
    begin
      if CDS_Main.fieldbyname('SSEL').AsBoolean then
      begin
        if wsql = ' ' then
          wsql := wsql + quotedstr(trim(Trim(CDS_Main.fieldbyname('spid').AsString)))
        else
          wsql := wsql + ',' + quotedstr(trim(Trim(CDS_Main.fieldbyname('spid').AsString)));

      end;
      Next;

      CDS_Main.EnableControls;
    end;
    wsql := '(' + wsql + ')';
//    wsql := wsql + ')';
    CDS_Main.DisableControls;
  end;
  with ADOPrint do
  begin
    Close;
    sql.Clear;
    SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYID=A.CYID) from ck_sxpb_cr A where spid in' + (Trim(wsql)));
    SQL.Add('ORDER BY ORDERNO,CYENAME,SPHX');
//    ShowMessage(SQL.Text);
    Open;
  end;

  if FileExists(fPrintFile) then
  begin
//    RMVariables['SL'] := Trim(Edit2.text);

    RM1.LoadFromFile(fPrintFile);
    RMVariables['QRBARCODE'] := fImagePath;
//    Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1);
    RM1.SHOWReport;
  end
  else
  begin
    Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
  end;

end;

procedure TfrmZZJWLRKList.JWLLABNAMEPropertiesButtonClick(Sender: TObject; AButtonIndex: Integer);
begin
  try
    frmZDYHelp := TfrmZDYHelp.Create(Application);
    with frmZDYHelp do
    begin
      flag := 'JWLLABNAME';
      flagname := '机物料标签名';
      if ShowModal = 1 then
      begin

        JWLLABNAME.text := Trim(frmZDYHelp.ClientDataSet1.fieldbyname('ZdyName').AsString);

      end;
    end;
  finally
    frmZDYHelp.Free;
  end;
end;

procedure TfrmZZJWLRKList.Button3Click(Sender: TObject);
var
  fPrintFile: string;
  EngMoney: string;
  Porderno, LBName, SYRName: string;
  i, j: Integer;
  OrderKg: Double;
  FDate: string;
  Txt, fImagePath: string;
  Moudle: THandle;
  Makebar: TMakebar;
  Mixtext: TMixtext;
  FLABNAME: string;
begin
  if CDS_Main.IsEmpty then
    Exit;
  if CDS_Main.Locate('SSel', True, []) = False then
  begin
    Application.MessageBox('没有选择数据!', '提示', 0);
    Exit;
  end;
//  if Edit2.Text = '' then
//  begin
//    application.MessageBox('每箱盒数不能为空！', '提示信息', MB_ICONERROR);
//    Exit;
//  end;
  if Edit3.Text = '' then
  begin
    application.MessageBox('打印份数不能为空！', '提示信息', MB_ICONERROR);
    Exit;
  end;

  if JWLLABNAME.Text = '' then
  begin
    FLABNAME := '机物料出库单';
  end
  else
  begin
    FLABNAME := JWLLABNAME.Text;
  end;
  ExportFtErpFile(FLABNAME + '.rmf', ADOQueryTemp);
  fPrintFile := ExtractFilePath(Application.ExeName) + 'Report\' + FLABNAME + '.rmf';

  CDS_Main.DisableControls;
  with CDS_Main do
  begin
    First;
    while not Eof do
    begin
      if CDS_Main.FieldByName('SSel').AsBoolean = True then
      begin
        with ADOPrint do
        begin
          Close;
          sql.Clear;
          SQL.Add('select *,cyename=(select CYENAME FROM fl_ydang B WHERE B.CYmjID=A.CYID)');
          SQL.Add(',CYCF=(select CYCF FROM fl_ydang B WHERE B.CYmjID=A.CYID) from ck_sxpb_cr A where spid=' + QUOTEDSTR(Trim(CDS_Main.fieldbyname('spid').AsString)));
          Open;

        end;

        if FileExists(fPrintFile) then
        begin
          if Edit2.Text <> '' then
          begin
            RMVariables['SL'] := Trim(Edit2.text);
          end
          else
          begin
            RMVariables['SL'] := ADOPrint.FieldByName('piQty').AsFloat;
          end;



//
//    //RMVariables['enddate']:=enddate.DateTime;
//    try
//      Moudle := LoadLibrary('MakeQRBarcode.dll');
//      @Makebar := GetProcAddress(Moudle, 'Make');
//      @Mixtext := GetProcAddress(Moudle, 'MixText');
//      Txt := Trim((trim(CDS_Main.fieldbyname('spid').AsString)));
//      fImagePath := ExtractFilePath(Application.ExeName) + 'image\temp.bmp';
//      if not DirectoryExists(pchar(ExtractFilePath(Application.ExeName) + 'image')) then
//        CreateDirectory(pchar(ExtractFilePath(Application.ExeName) + 'image'), nil);
//      if FileExists(fImagePath) then
//        DeleteFile(fImagePath);
//      Makebar(pchar(Txt), Length(Txt), 3, 3, 0, PChar(fImagePath), 3);
//    except
//      application.MessageBox('条形码生成失败！', '提示信息', MB_ICONERROR);
//      exit;
//    end;
          RM1.LoadFromFile(fPrintFile);
          RMVariables['QRBARCODE'] := fImagePath;
          RMVariables['CYMJID'] := CDS_Main.FIELDBYNAME('CYMJID').AsString;
          if (ADOPrint.FieldByName('qtyunit').ASSTRING = '箱') then
          begin

            Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1) * strtointdef(ADOPrint.FieldByName('zhs').AsString, 1);

          end
          else
          begin
            Rm1.DefaultCopies := strtointdef(trim(EDIT3.Text), 1);
          end;
          RM1.showReport;
        end
        else
        begin
          Application.MessageBox(PChar('没有找' + fPrintFile), '提示', 0);
        end;
      end;
      Next;
    end;
  end;
  CDS_Main.EnableControls;

end;

end.

